/* Copyright Statement:
 * (C) 2005-2016 MediaTek Inc. All rights reserved.
 *
 * This software/firmware and related documentation ("MediaTek Software") are
 * protected under relevant copyright laws. The information contained herein
 * is confidential and proprietary to MediaTek Inc. ("MediaTek") and/or its licensors.
 * Without the prior written permission of MediaTek and/or its licensors,
 * any reproduction, modification, use or disclosure of MediaTek Software,
 * and information contained herein, in whole or in part, shall be strictly prohibited.
 * You may only use, reproduce, modify, or distribute MediaTek Software
 * if you have agreed to and been granted explicit permission within
 * the "License Agreement" that is available on MediaTek's website ("Website") before
 * downloading the relevant MediaTek Software from the Website ("Permitted User").
 * If you are not a Permitted User, please cease any access or use of MediaTek Software immediately.
 *
 * BY OPENING THIS FILE, RECEIVER HEREBY UNEQUIVOCALLY ACKNOWLEDGES AND AGREES
 * THAT MEDIATEK SOFTWARE RECEIVED FROM MEDIATEK AND/OR ITS REPRESENTATIVES 
 * ARE PROVIDED TO RECEIVER ON AN "AS-IS" BASIS ONLY. MEDIATEK EXPRESSLY DISCLAIMS ANY AND ALL 
 * WARRANTIES, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE OR NONINFRINGEMENT.
 * NEITHER DOES MEDIATEK PROVIDE ANY WARRANTY WHATSOEVER WITH RESPECT TO THE
 * SOFTWARE OF ANY THIRD PARTY WHICH MAY BE USED BY, INCORPORATED IN, OR
 * SUPPLIED WITH MEDIATEK SOFTWARE, AND RECEIVER AGREES TO LOOK ONLY TO SUCH
 * THIRD PARTY FOR ANY WARRANTY CLAIM RELATING THERETO. RECEIVER EXPRESSLY ACKNOWLEDGES
 * THAT IT IS RECEIVER'S SOLE RESPONSIBILITY TO OBTAIN FROM ANY THIRD PARTY ALL PROPER LICENSES
 * CONTAINED IN MEDIATEK SOFTWARE. MEDIATEK SHALL ALSO NOT BE RESPONSIBLE FOR ANY MEDIATEK
 * SOFTWARE RELEASES MADE TO RECEIVER'S SPECIFICATION OR TO CONFORM TO A PARTICULAR
 * STANDARD OR OPEN FORUM. RECEIVER'S SOLE AND EXCLUSIVE REMEDY AND MEDIATEK'S ENTIRE AND
 * CUMULATIVE LIABILITY WITH RESPECT TO MEDIATEK SOFTWARE RELEASED HEREUNDER WILL BE,
 * AT MEDIATEK'S OPTION, TO REVISE OR REPLACE MEDIATEK SOFTWARE AT ISSUE,
 * OR REFUND ANY SOFTWARE LICENSE FEES OR SERVICE CHARGE PAID BY RECEIVER TO
 * MEDIATEK FOR SUCH MEDIATEK SOFTWARE AT ISSUE.
 */
#include <stdint.h>
#include <stdio.h>
#include <string.h>

#include "FreeRTOS.h"
#include "task.h"
#include "net_init.h"
#include "network_init.h"
#include "wifi_api.h"

#include "syslog.h"
#include "aliyun_iot_mqtt_client.h"

void mqtt_proc(void *args)
{
    LOG_I(common, "MQTT client example begin");
    mqtt_client_demo();
    LOG_I(common, "MQTT client example end");
    while (1) {
    }
}

int is_mqtt_thread_enter = 0;
void ip_ready_callback(const struct netif *netif)
{
	//aliyun_iot_mqtt_network_event_callback(ALI_IOT_NETWORK_CONNECTED,NULL);

	if(1 == is_mqtt_thread_enter)
	{
		LOG_I(common, "mqtt thread enter again");
		return;
	}
	is_mqtt_thread_enter = 1;
    TaskHandle_t xCreatedTask;
    portBASE_TYPE type = xTaskCreate(mqtt_proc, "mqttex", 2048*2, NULL, 1, &xCreatedTask);
    LOG_I(common, "xTaskCreate mqtt_proc -- %d", type);
}

void wifi_connect_init(void *args)
{
    LOG_I(common, "enter connect init.");
    uint8_t opmode  = WIFI_MODE_STA_ONLY;
    uint8_t port = WIFI_PORT_STA;
    uint8_t *ssid = "A0002";
    wifi_auth_mode_t auth = WIFI_AUTH_MODE_WPA_PSK_WPA2_PSK;
    wifi_encrypt_type_t encrypt = WIFI_ENCRYPT_TYPE_TKIP_AES_MIX;
    uint8_t *password = "12345678";
    uint8_t nv_opmode;

    if (wifi_config_init() == 0) {
        wifi_config_get_opmode(&nv_opmode);
        if (nv_opmode != opmode) {
            wifi_config_set_opmode(opmode);
        }
        wifi_config_set_ssid(port, ssid ,strlen(ssid));
        wifi_config_set_security_mode(port, auth, encrypt);
        wifi_config_set_wpa_psk_key(port, password, strlen(password));
        wifi_config_reload_setting();

        network_dhcp_start(opmode);
    }
    vTaskDelete(NULL);
}


int main(void)
{
    system_init();
    wifi_register_ip_ready_callback(ip_ready_callback);
    network_init();
    xTaskCreate(wifi_connect_init,"wifi_connect",1024,NULL,1,NULL);

    vTaskStartScheduler();
    while (1) {
    }
    return 0;
}

